//---------------------------------------------------------------------------
// TDcjCustomDlg Abstract Class
//
// Copyright  1998, Michael Trier.  All Rights Reserved.
//---------------------------------------------------------------------------
// This component and its associated property editor and component editor can be
// freely used and distributed, provided all source code files are not modified
// in any way and there is no charge for it other than nominal shipping and
// handling fees.  Please contact me directly if you desire to modify the terms
// of this agreement.
//---------------------------------------------------------------------------
// Please note:  This source code is provided as a teaching tool. If you
// decide that you want to use whole routines or modules directly in an
// application that you are creating, please give credit where it is due.
// Given the above, keep in mind that these applications are copyright
// property of Michael Trier.
//---------------------------------------------------------------------------
// Date last modified: $Date: 1998/10/30 03:02:38 $
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// TDcjCustomDlg v$Revision: 0.51 $
//---------------------------------------------------------------------------
// Revision History:
// $Log: DcjCustomDlg.cpp,v $
// Revision 0.51  1998/10/30 03:02:38  michael
// converted TDcjMessageDlg so that it now descends from TDcjCustomDlg.
//
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <memory>
#pragma hdrstop

#include "DcjCustomDlg.h"
#ifndef DCJ_BCB_1
  #pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
// TDcjDialogForm Implementation
//---------------------------------------------------------------------------
void __fastcall TDcjDialogForm::HelpButtonClick(System::TObject* Sender)
{
  Application->HelpContext(HelpContext);
}
//---------------------------------------------------------------------------
// TDcjCustomDlg Implementation
//---------------------------------------------------------------------------
__fastcall TDcjCustomDlg::TDcjCustomDlg(TComponent* Owner)
  : TComponent(Owner)
{
  // initialize properties
  FCaption = "";
  FText = "";
  FFont = NULL;
  FHelpContext = 0;
  FModalResult = mrNone;

  FFont = new TFont();
}
//---------------------------------------------------------------------------
__fastcall TDcjCustomDlg::~TDcjCustomDlg(void)
{
  // free up the memory
  delete FFont;
  FFont = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TDcjCustomDlg::Assign(TPersistent *Source)
{
  // assign the source object to the destination
  if( Source->InheritsFrom(__classid(TDcjCustomDlg)) ) {
    // cast the TPersistant object to a TDcjCustomDlg object
    TDcjCustomDlg *source = dynamic_cast<TDcjCustomDlg *>(Source);
    // assign the properties
    FCaption = source->Caption;
    FFont->Assign(source->Font);
    FText = source->Text;
    FModalResult = source->ModalResult;
    FHelpContext = source->HelpContext;
  }
}
//---------------------------------------------------------------------------
bool __fastcall TDcjCustomDlg::Execute(void)
{
  // create the message dialog and return the result
  bool result = false;

  TDcjDialogForm *dialog = CreateDcjDialog();
  try {
    // display the dialog and return the modal result
    FModalResult = dialog->ShowModal();
    result = true;
  }
  catch(...) {
    delete dialog;
    dialog = NULL;
  }
  // free up the memory
  delete dialog;
  dialog = NULL;

  return result;
}
//---------------------------------------------------------------------------
void __fastcall TDcjCustomDlg::SetFont(TFont *Value)
{
  // set the font to the specified value
  FFont->Assign(Value);
}
//---------------------------------------------------------------------------
void __fastcall TDcjCustomDlg::SetModalResult(TModalResult Value)
{
  // write out the modal result
  if( ModalResult != Value )
    FModalResult = Value;
}
//---------------------------------------------------------------------------
void __fastcall TDcjCustomDlg::SetVersion(AnsiString Value)
{
  // this is a read-only property so we implement an empty function body
}
//---------------------------------------------------------------------------

